diff --git a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
index bc8f0e509..a34f6a9d6 100644
--- a/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
+++ b/game/core/src/main/java/net/minecraft/core/util/helper/Direction.java
@@ -1,221 +1,600 @@
 package net.minecraft.core.util.helper;
 
-import net.minecraft.core.entity.Mob;
+import java.util.Arrays;
+
 import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+import org.joml.Vector3f;
+import org.joml.Vector3i;
+
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.world.pos.TilePos;
 
 public enum Direction {
-	
-	NORTH(Axis.Z, 0, 0, -1, "north"),
-	EAST(Axis.X, 1, 0, 0, "east"),
-	SOUTH(Axis.Z, 0, 0, 1, "south"),
-	WEST(Axis.X, -1, 0, 0, "west"),
-	UP(Axis.Y, 0, 1, 0, "up"),
-	DOWN(Axis.Y, 0, -1, 0, "down"),
-	NONE(Axis.NONE, 0, 0, 0, "none");
-	
-	public static final @NotNull Direction @NotNull [] directions = new Direction[6];
-	public static final @NotNull Direction @NotNull [] horizontalDirections = new Direction[4];
-	
-	static {
-		setId(DOWN, 0);
-		setId(UP, 1);
-		setId(NORTH, 2);
-		setId(SOUTH, 3);
-		setId(WEST, 4);
-		setId(EAST, 5);
-		NONE.id = -1;
-		
-		setHorizontal(NORTH, 0);
-		setHorizontal(EAST, 1);
-		setHorizontal(SOUTH, 2);
-		setHorizontal(WEST, 3);
-		
-		setOpposites(EAST, WEST);
-		setOpposites(UP, DOWN);
-		setOpposites(NORTH, SOUTH);
-		NONE.opposite = NONE;
-		
-		UP.side = Side.TOP;
-		DOWN.side = Side.BOTTOM;
-		NORTH.side = Side.NORTH;
-		EAST.side = Side.EAST;
-		SOUTH.side = Side.SOUTH;
-		WEST.side = Side.WEST;
-		NONE.side = Side.NONE;
-		
-		NORTH.index = 0;
-		EAST.index = 1;
-		SOUTH.index = 2;
-		WEST.index = 3;
-		UP.index = 4;
-		DOWN.index = 5;
-	}
-	
-	private static void setId(Direction side, int id) {
-		directions[id] = side;
-		side.id = id;
-	}
-	
-	private static void setHorizontal(Direction direction, int id) {
-		horizontalDirections[id] = direction;
-		direction.horizontalIndex = id;
-	}
-	
-	private static void setOpposites(Direction side1, Direction side2) {
-		side1.opposite = side2;
-		side2.opposite = side1;
-	}
-
-	/////////////////////
-	
-	public static @NotNull Direction getDirectionById(int i) {
-		if(i >= 0 && i < directions.length) {
-			return directions[i];
-		}else {
-			return NONE;
-		}
-	}
-
-	/////////////////////
-
-	private final Axis axis;
-	private int id;
-	private int horizontalIndex;
-	private Direction opposite;
-	private Side side;
-	
-	private final int offsetX;
-	private final int offsetY;
-	private final int offsetZ;
-	private final String translationKey;
-	
-	@Deprecated
-	public int index;
-	
-	Direction(Axis axis, int offsetX, int offsetY, int offsetZ, String translationKey) {
-		this.axis = axis;
-		this.offsetX = offsetX;
-		this.offsetY = offsetY;
-		this.offsetZ = offsetZ;
-		this.translationKey = "direction." + translationKey;
-	}
-	
-	public int getOffsetX() {
-		return offsetX;
-	}
-	
-	public int getOffsetY() {
-		return offsetY;
-	}
-	
-	public int getOffsetZ() {
-		return offsetZ;
-	}
-
-	public String getTranslationKey() {
-		return translationKey;
-	}
-	
-	public @NotNull Direction getOpposite() {
-		return opposite;
-	}
-	
-	public Side getSide() {
-		return side;
-	}
-	
-	public @NotNull Axis getAxis() {
-		return axis;
-	}
-	
-	public int getId() {
-		return id;
-	}
-
-	public boolean isVertical() {
-		return getAxis().isVertical();
-	}
-	
-	public boolean isHorizontal() {
-		return !isVertical();
-	}
-
-	public Direction rotate(int amount) {
-		if(this == UP) return UP;
-		if(this == DOWN) return DOWN;
-		return horizontalDirections[(getHorizontalIndex() + amount) & 3];
-	}
-	
-	public int getHorizontalIndex() {
-		return horizontalIndex;
-	}
-	
-	/////////////////////
-	
-	public static Direction getVerticalDirection(double rotationPitch) {
-		if(rotationPitch < 0) return UP;
-		else return DOWN;
-	}
-	
-	public static Direction getVerticalDirection(Mob entity) {
-		if(entity.rotationLockVertical != null && entity.rotationLockVertical != NONE) return entity.rotationLockVertical;
-		else return getVerticalDirection(entity.xRot);
-	}
-	
-	public static @NotNull Direction getHorizontalDirection(final double rotationYaw) {
-		return horizontalDirections[(MathHelper.floor(rotationYaw / 90f + 0.5) + 2) & 3];
-	}
-	
-	public static @NotNull Direction getHorizontalDirection(final @NotNull Mob mob) {
-		if (mob.rotationLockHorizontal != null && mob.rotationLockHorizontal != NONE) return mob.rotationLockHorizontal;
-		return getHorizontalDirection(mob.yRot);
-	}
-	
-	public static @NotNull Direction getDirection(final @NotNull Mob mob) {
-		if (mob.rotationLock != null && mob.rotationLock != NONE) return mob.rotationLock;
-		if (mob.xRot < -45) return UP;
-		if (mob.xRot > 45) return DOWN;
-		return getHorizontalDirection(mob.yRot);
-	}
-
-	//////////////////
-
-	public static @NotNull Direction[] rotXMap = new Direction[] {
-		Direction.DOWN, Direction.NORTH, Direction.UP, Direction.SOUTH,
-		Direction.UP, Direction.SOUTH, Direction.DOWN, Direction.NORTH,
-		Direction.NORTH, Direction.UP, Direction.SOUTH, Direction.DOWN,
-		Direction.SOUTH, Direction.DOWN, Direction.NORTH, Direction.UP,
-		Direction.WEST, Direction.WEST, Direction.WEST, Direction.WEST,
-		Direction.EAST, Direction.EAST, Direction.EAST, Direction.EAST,
-	};
-
-	public static @NotNull Direction rotateX(@NotNull Direction direction, int amount) {
-		return rotXMap[direction.getId() * 4 + (amount & 0b11)];
-	}
-
-	public static @NotNull Direction[] rotYMap = new Direction[] {
-		Direction.DOWN, Direction.DOWN, Direction.DOWN, Direction.DOWN,
-		Direction.UP, Direction.UP, Direction.UP, Direction.UP,
-		Direction.NORTH, Direction.WEST, Direction.SOUTH, Direction.EAST,
-		Direction.SOUTH, Direction.EAST, Direction.NORTH, Direction.WEST,
-		Direction.WEST, Direction.SOUTH, Direction.EAST, Direction.NORTH,
-		Direction.EAST, Direction.NORTH, Direction.WEST, Direction.SOUTH,
-	};
-
-	public static @NotNull Direction rotateY(@NotNull Direction direction, int amount) {
-		return rotYMap[direction.getId() * 4 + (amount & 0b11)];
-	}
-
-	public static @NotNull Direction[] rotZMap = new Direction[] {
-		Direction.DOWN, Direction.EAST, Direction.UP, Direction.WEST,
-		Direction.UP, Direction.WEST, Direction.DOWN, Direction.EAST,
-		Direction.NORTH, Direction.NORTH, Direction.NORTH, Direction.NORTH,
-		Direction.SOUTH, Direction.SOUTH, Direction.SOUTH, Direction.SOUTH,
-		Direction.WEST, Direction.DOWN, Direction.EAST, Direction.UP,
-		Direction.EAST, Direction.UP, Direction.WEST, Direction.DOWN,
-	};
-
-	public static @NotNull Direction rotateZ(@NotNull Direction direction, int amount) {
-		return rotZMap[direction.getId() * 4 + (amount & 0b11)];
-	}
+    DOWN  (0b000, "north"),
+    UP    (0b001, "east"),
+    NORTH (0b010, "south"),
+    SOUTH (0b011, "west"),
+    WEST  (0b100, "up"),
+    EAST  (0b101, "down"),
+
+    /**
+     * Method implementations might not guarantee correct behaviour (error safety) when passed
+     * NONE. Prefer passing {@code null} if method accepts {@code @Nullable Direction},
+     * or an acceptable default direction, or avoid calling the method entirely!
+     */
+    @Deprecated
+    NONE  (0b000, "none"); // NONE will always index as down to simplify things :|
+
+    public final int id;
+    public final String translationKey;
+
+    private Direction(int id, String translationKey) {
+        this.id = id;
+        this.translationKey = "direction." + translationKey;
+    }
+
+    public static final int count = 6;
+    public static final int horizontalCount = 4;
+
+    // Lookup:
+    // ============================
+
+    /**
+     * returns a valid direction when id >= 0 && < 6, otherwise NONE. <br><br>
+     * NOTE:
+     */
+    public static @NotNull Direction fromId(int id) {
+        return ((id & ~0b111) == 0)
+            ? OPTIONAL_MAP[id] // NONE if >= 6
+            : NONE;
+    }
+
+    public static @NotNull Direction fromIdOrDefault(int id) {
+        if (id >= 0 && id < 6) id = 0;
+        return ID_MAP[id];
+    }
+
+    public static Direction fromIdOrDefault(Direction direction, int id) {
+        return (id >= 0 && id < 6)
+            ? ID_MAP[id]
+            : direction;
+    }
+
+    /**
+     * simpler lookup logic, but can yield non-NONE result for index < 0 || >= 6
+     */
+    public static @NotNull Direction fromIdLenient(int id) {
+        return OPTIONAL_MAP[id & 0b111];
+    }
+
+    /**
+     * Perfer using {@code fromId(id)}.
+     * Index directly only if you are certain that the index is in bound;
+     * alternatively, if you want an always valid but may be incorrest result,
+     * use {@code ID_MAP[id % 6]}. <br><br>
+     *
+     * Directions follow the order [ -y, +y, -z, +z, -x, +x ]
+     *
+     * @see Direction#fromId(int)
+     */
+    public static final @NotNull Direction @NotNull[] ID_MAP = {
+        DOWN, UP,
+        NORTH, SOUTH,
+        WEST, EAST,
+    };
+
+    public static final @NotNull Direction @NotNull[] all = ID_MAP;
+
+    private static final Direction[] OPTIONAL_MAP = {
+        DOWN, UP,
+        NORTH, SOUTH,
+        WEST, EAST,
+        NONE, NONE, // [6..8]
+    };
+
+    public static final @NotNull Direction @NotNull[] horizontal = { NORTH, EAST, SOUTH, WEST };
+
+    @Deprecated
+    public int legacyIndex() {
+        return switch (this) {
+            default -> 0;
+            case NORTH -> 0;
+            case EAST -> 1;
+            case SOUTH -> 2;
+            case WEST -> 3;
+            case UP -> 4;
+            case DOWN -> 5;
+        };
+    }
+
+    @Deprecated
+    public int legacyHorizontalIndex() {
+        return switch (this) {
+            default -> 0;
+            case NORTH -> 0;
+            case EAST -> 1;
+            case SOUTH -> 2;
+            case WEST -> 3;
+        };
+    }
+
+    // Friends:
+    // ============================
+
+    public @NotNull Side side() {
+        return Side.fromId(this.id);
+    }
+
+    private static final Axis[] AXIS_YZX_MAP = { Axis.Y, Axis.Z, Axis.X };
+    // private static final Axis[] AXIS_XYZ_MAP = { Axis.X, Axis.Y, Axis.Z };
+
+    public @NotNull Axis axis() {
+        return AXIS_YZX_MAP[this.id >> 1];
+    }
+
+
+    // Rotation:
+    // ============================
+
+    public boolean isVertical() {
+        if (this == NONE) return false;
+        return isVerticle(this.id);
+    }
+    
+    // we don't care about NONE in the int version
+    public static boolean isVerticle(int id) {
+        return (id & 0b110) == 0;
+    }
+    
+    public boolean isHorizontal() {
+        if (this == NONE) return false;
+        return isHorizontal(this.id);
+    }
+
+    public static boolean isHorizontal(int id) {
+        return (id & 0b110) != 0;
+    }
+
+    public static @NotNull Direction fromPitch(double pitch) {
+        return (fpSign(pitch) == 0) ? DOWN : UP;
+    }
+
+    // handles +-0 correctly
+    // does not return meaningful output for NaN however!
+    private static int fpSign(double x) {
+        final long raw = Double.doubleToRawLongBits(x);
+        final int sign = (int) (raw >>> 63);
+        assert sign == 0 || sign == 1;
+        return sign;
+    }
+
+    public static @NotNull Direction fromYaw(double yaw) {
+        final double yawRightHanded = -yaw;
+        final int quarterTurnsFromNegX = MathHelper.floor(yawRightHanded / 90D + 0.5f);
+        final int quarterTurnsFromPosX = quarterTurnsFromNegX + 2;
+
+        return ID_MAP[ROT_MAPS[1][quarterTurnsFromPosX & 0b11]];
+    }
+
+    public static @NotNull Direction getVerticalLockable(@NotNull Mob mob) {
+        return (mob.rotationLockVertical != null)
+            ? mob.rotationLockVertical
+            : fromPitch(mob.xRot);
+    }
+
+    public static @NotNull Direction getHorizontalLockable(@NotNull Mob mob) {
+        return (mob.rotationLockHorizontal != null)
+            ? mob.rotationLockHorizontal
+            : fromYaw(mob.yRot);
+    }
+
+    public static @NotNull Direction getLockable(@NotNull Mob mob) {
+        if (mob.rotationLock != null) return mob.rotationLock;
+
+        // both of these would be false if NaN
+        if (mob.xRot < -45) return UP;
+        if (mob.xRot > 45) return DOWN;
+
+        return fromYaw(mob.yRot);
+    }
+
+    private static final int[][] ROT_MAPS = {
+        // X: -y, -z, +y, +z
+        { DOWN.id, NORTH.id, UP.id, SOUTH.id },
+
+        // Y: -x, +z, +x, -z
+        { NORTH.id, WEST.id, SOUTH.id, EAST.id },
+
+        // Z: -y, +x, +y, -x
+        { DOWN.id, EAST.id, UP.id, WEST.id },
+    };
+
+    private static final int[][] ROT_INDEX_MAPS = new int[3][6];
+    static {
+        for (int axis = 0; axis < 3; axis ++) {
+            Arrays.fill(ROT_INDEX_MAPS[axis], -1);
+            for (int i = 0; i < 4; i++) {
+                final int dir = ROT_MAPS[axis][i];
+                ROT_INDEX_MAPS[axis][dir] = i;
+            }
+        }
+    }
+
+    /**
+     * Right-handed around the +X axis
+     */
+    public @NotNull Direction rotateX(int quarterTurns) {
+        if (this == NONE) return this;
+        return ID_MAP[rotate(this.id, 0, quarterTurns)];
+    }
+
+    /**
+     * Right-handed around the +X axis
+     */
+    public static int rotateX(int id, int quarterTurns) {
+        return rotate(id, 0, quarterTurns);
+    }
+
+    /**
+     * Right-handed rotation around the +Y axis
+     */
+    public @NotNull Direction rotateY(int quarterTurns) {
+        if (this == NONE) return this;
+        return ID_MAP[rotate(this.id, 1, quarterTurns)];
+    }
+
+    /**
+     * Right-handed rotation around the +Y axis
+     */
+    public static int rotateY(int id, int quarterTurns) {
+        return rotate(id, 1, quarterTurns);
+    }
+
+    /**
+     * Right-handed rotation around the +Z axis
+     */
+    public @NotNull Direction rotateZ(int quarterTurns) {
+        if (this == NONE) return this;
+        return ID_MAP[rotate(this.id, 2, quarterTurns)];
+    }
+
+    /**
+     * Right-handed rotation around the +Z axis
+     */
+    public static int rotateZ(int id, int quarterTurns) {
+        return rotate(id, 2, quarterTurns);
+    }
+
+    /**
+     * Right-handed rotation around the given positive axis
+     */
+    public @NotNull Direction rotate(@NotNull Axis axis, int quarterTurns) {
+        if (this == NONE) return this;
+        return ID_MAP[rotate(this.id, axis.xyzIndex, quarterTurns)];
+    }
+
+    /**
+     * Right-handed rotation around the given positive axis
+     */
+    public static int rotate(int id, @NotNull Axis axis, int quarterTurns) {
+        return rotate(id, axis.xyzIndex, quarterTurns);
+    }
+
+    /**
+     * Right-handed rotation around the given positive axis,
+     * where +X, +Y, +Z are represented as 0, 1, 2 respectively
+     */
+    public static int rotate(int id, int axis, int quarterTurns) {
+        axis &= 0b11; assert axis < 3;
+        id &= 0b111; assert id < 6;
+
+        
+        final int ridx = ROT_INDEX_MAPS[axis][id];
+        if (ridx < 0) return id;
+
+        return ROT_MAPS[axis][(ridx + quarterTurns) & 0b11];
+    }
+
+
+    // Offset:
+    // ============================
+
+    private static final int[] CMP_MAP = { 1, 2, 0 };
+
+    public int componentIndex() {
+        if (this == NONE) return 0; // instead of -1 :|
+        final int res = componentIndex(this.id);
+        assert res >= 0;
+        return res;
+    }
+
+    public static int componentIndex(int id) {
+        id = (id >>> 1) & 0b11;
+        assert id != 0b11;
+        return CMP_MAP[id];
+    }
+
+    public int sign() {
+        if (this == NONE) return 0;
+        return sign(this.id);
+    }
+
+    public static int sign(int id) {
+        return ~id & 1;
+    }
+
+    public @NotNull Direction opposite() {
+        if (this == NONE) return this;
+        final var id = opposite(this.id);
+        assert id >= 0 && id < 6;
+        return ID_MAP[id];
+    }
+
+    public static int opposite(int id) {
+        return id ^ 1;
+    }
+
+    public boolean isPositive() {
+        if (this == NONE) return false;
+        return this.sign() == 0;
+    }
+
+    public boolean isNegative() {
+        if (this == NONE) return false;
+        return this.sign() == 1;
+    }
+
+    public static final int[][] OFFSETS = new int[3][6];
+    static {
+        for (int i = 0; i < 6; i++) {
+            OFFSETS[componentIndex(i)][i] = 1 - (sign(i) << 1);
+        }
+    }
+
+    public int offsetX() {
+        if (this == NONE) return 0;
+        return offsetX(this.id);
+    }
+    public int offsetY() {
+        if (this == NONE) return 0;
+        return offsetY(this.id);
+    }
+    public int offsetZ() {
+        if (this == NONE) return 0;
+        return offsetZ(this.id);
+    }
+
+    public static int offsetX(int id) {
+        id &= 0b111; assert id < 6;
+        return OFFSETS[0][id];
+    }
+
+    public static int offsetY(int id) {
+        id &= 0b111; assert id < 6;
+        return OFFSETS[1][id];
+    }
+
+    public static int offsetZ(int id) {
+        id &= 0b111; assert id < 6;
+        return OFFSETS[2][id];
+    }
+
+    // ---------
+
+    // all these api to ensure conveniency while avoid redundant allocation ...
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public @NotNull Vector3i getOffset(@NotNull Vector3i out) {
+        if (this == NONE) return out.set(0,0,0);
+        return getOffset(this.id, out);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public @NotNull Vector3d getOffset(@NotNull Vector3d out) {
+        if (this == NONE) return out.set(0,0,0);
+        return getOffset(this.id, out);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public @NotNull Vector3i getOffsetScaled(@NotNull Vector3i out, int scale) {
+        if (this == NONE) return out.set(0,0,0);
+        return getOffsetScaled(this.id, out, scale);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public @NotNull Vector3d getOffsetScaled(@NotNull Vector3d out, double scale) {
+        if (this == NONE) return out.set(0,0,0);
+        return getOffsetScaled(this.id, out, scale);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public @NotNull Vector3f getOffsetScaled(@NotNull Vector3f out, float scale) {
+        if (this == NONE) return out.set(0,0,0);
+        return getOffsetScaled(this.id, out, scale);
+    }
+
+    // ---------
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3i getOffset(int id, @NotNull Vector3i out) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3d getOffset(int id, @NotNull Vector3d out) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3f getOffset(int id, @NotNull Vector3f out) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3i getOffsetScaled(int id, @NotNull Vector3i out, int scale) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3d getOffsetScaled(int id, @NotNull Vector3d out, double scale) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    /**
+     * @param out the location where the offset is written to.
+     */
+    public static @NotNull Vector3f getOffsetScaled(int id, @NotNull Vector3f out, float scale) {
+        id &= 0b111; assert id < 6;
+        return out.set(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    // ---------
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull TilePos offset(@NotNull TilePos ref) {
+        if (this == NONE) return ref;
+        return offset(this.id, ref);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull Vector3i offset(@NotNull Vector3i ref) {
+        if (this == NONE) return ref;
+        return offset(this.id, ref);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull Vector3d offset(@NotNull Vector3d ref) {
+        if (this == NONE) return ref;
+        return offset(this.id, ref);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull TilePos offsetScaled(@NotNull TilePos ref, int scale) {
+        if (this == NONE) return ref;
+        return offsetScaled(this.id, ref, scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull Vector3i offsetScaled(@NotNull Vector3i ref, int scale) {
+        if (this == NONE) return ref;
+        return offsetScaled(this.id, ref, scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull Vector3d offsetScaled(@NotNull Vector3d ref, double scale) {
+        if (this == NONE) return ref;
+        return offsetScaled(this.id, ref, scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public @NotNull Vector3f offsetScaled(@NotNull Vector3f ref, float scale) {
+        if (this == NONE) return ref;
+        return offsetScaled(this.id, ref, scale);
+    }
+
+    // ---------
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull TilePos offset(int id, @NotNull TilePos ref) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3i offset(int id, @NotNull Vector3i ref) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3d offset(int id, @NotNull Vector3d ref) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3f offset(int id, @NotNull Vector3f ref) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id], OFFSETS[1][id], OFFSETS[2][id]);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3d offsetScaled(int id, @NotNull Vector3d ref, double scale) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull TilePos offsetScaled(int id, @NotNull TilePos ref, int scale) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3i offsetScaled(int id, @NotNull Vector3i ref, int scale) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
+
+    /**
+     * @param ref the location where the offset is applied to.
+     */
+    public static @NotNull Vector3f offsetScaled(int id, @NotNull Vector3f ref, float scale) {
+        id &= 0b111; assert id < 6;
+        return ref.add(OFFSETS[0][id] * scale, OFFSETS[1][id] * scale, OFFSETS[2][id] * scale);
+    }
 }
